/*
 * oscil_can.h
 *
 *  Created on: 24  2020 .
 *      Author: yura
 */

#ifndef SRC_LIBS_NIO12_ALARM_LOG_CAN_H_
#define SRC_LIBS_NIO12_ALARM_LOG_CAN_H_

#define CAN_BOX_PRIORITY_LOW_MAX_SIZE_BLOCKS 195L //3330L  // 9999L


#define ALARM_LOG_NUMBER_BOX_IN_CAN                    0

#define ALARM_LOG_CODE_STATUS_LOG_STOP          1   //  
#define ALARM_LOG_CODE_STATUS_LOG_RUN           2   //  ...
#define ALARM_LOG_CODE_STATUS_LOG_RUN_TO_STOP   3   //  ,   ,  .


/*
#define OSCIL_CAN_NUMBER_CHANNEL            32      //   -   
#define OSCIL_CAN_NUMBER_POINTS             500     //   -    (  )
#define OSCIL_TIME_WAIT                     5000    //      CAN ()
#define OSCIL_CAN_NUMBER_POINTS_ADD         100     //          . oscil_buffer->temp_oscil_buffer

#define OSCIL_CAN_NUMBER_POINTS_AFTER_STOP  100     //           
*/


typedef struct {
    unsigned int global_enable;             //   
    unsigned int copy2temp;                 //    temp  
    unsigned int stage;

    int cmd_fffc[3];
    int cmd_fffd[3];
    int cmd_fffe[3];
    int cmd_ffff[3];

    unsigned int post_points;               // -   
    unsigned int step;                      //   , 
    unsigned int start;                     //   START
    unsigned int oscills;                   // -  - 

    unsigned long real_points;              //  - ,     = points*oscills
                                            //     ,         .

    unsigned int stop;                      //   START
    unsigned int crc16;                     // crc16 

    int *start_adr_real_logs;               //   ,  
                                            //       

    int *start_adr_temp;                    //   ,  
                                            //       ,        .

    int *finish_adr_real_log;               //   ,  
                                            //     

    int *current_adr_real_log;              //          

 //   int *finish_adr_temp;                   //    temp 
    unsigned long temp_points;              //  - ,     = temp_points*oscills
                                            //      .

    unsigned long progress_can;             //  ,   
    unsigned int prev_status_alarm;         // .  status_alarm
    unsigned int status_alarm;              //  ,         0->1

    unsigned int timer_send;                //    

    unsigned int temp_log_ready;            //   temp    CAN

    unsigned long can_max_size_one_block;    //      ,   3.

    void (*clear)();                        // Clear buffers
    void (*send)();                         // Send buffers
    void (*copy_temp_buffer)();             // Copy work buffers to temp buffers
    void (*prepare_data_can)();             //    

} ALARM_LOG_CAN;

typedef ALARM_LOG_CAN *ALARM_LOG_CAN_handle;



#define ALARM_LOG_CAN_CAN_DEFAULTS {  \
                                0, \
                                0, \
                                0, \
                                {0,0,0}, \
                                {0,0,0}, \
                                {0,0,0}, \
                                {0,0,0}, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                0, \
                                CAN_BOX_PRIORITY_LOW_MAX_SIZE_BLOCKS, \
                                alarm_log_clear_buffer, \
                                alarm_log_send_buffer, \
                                alarm_log_copy_temp_buffer, \
                                alarm_log_prepare_data_can \
}




void alarm_log_clear_buffer(ALARM_LOG_CAN_handle);
void alarm_log_send_buffer(ALARM_LOG_CAN_handle);
//void alarm_log_next_position(ALARM_LOG_CAN_handle);
void alarm_log_prepare_data_can(ALARM_LOG_CAN_handle);
void alarm_log_copy_temp_buffer(ALARM_LOG_CAN_handle);



extern ALARM_LOG_CAN alarm_log_can;

#endif /* SRC_LIBS_NIO12_ALARM_LOG_CAN_H_ */


