/*
 * control_station.h
 *
 *  Created on: 1 . 2020 .
 *      Author: Vladislav
 */

#ifndef SRC_LIBS_NIO12_CONTROL_STATION_H_
#define SRC_LIBS_NIO12_CONTROL_STATION_H_

#include <control_station_project.h> //    

#include "word_structurs.h"


//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////


#define COUNT_CONTROL_STATION                   CONTROL_STATION_LAST   // -  
//#define COUNT_CMD_ARR_CONTROL_STATION           CONTROL_STATION_LAST   // -  

//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////


#define CONTROL_STATION_TIME_WAIT                       250//500         //   

#define CONTROL_STATION_SETUP_TIME_DETECT_ACTIVE            18//12//6           //    CONTROL_STATION_TIME_WAIT
#define CONTROL_STATION_SETUP_TIME_DETECT_ACTIVE_RESEND_485 2           //    CONTROL_STATION_TIME_WAIT
#define CONTROL_STATION_SETUP_TIME_SEND_CMD_AFTER_OFF       5           //    CONTROL_STATION_TIME_WAIT

#define CONTROL_STATION_MAX_RAW_DATA                            256 //128         //  -       
#define CONTROL_STATION_MAX_RAW_DATA_TEMP                       3 //128         //      

//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////

typedef struct {

    unsigned int time_detect_active[COUNT_CONTROL_STATION];         //     ,    
    unsigned int period_detect_active[COUNT_CONTROL_STATION];       //    
    unsigned int time_detect_answer_485[COUNT_CONTROL_STATION];     //       Modbus

    unsigned int setup_time_detect_active[COUNT_CONTROL_STATION];       //      
    unsigned int setup_time_detect_active_resend_485[COUNT_CONTROL_STATION];  //      ,    setup_time_detect_active
    unsigned int setup_time_send_cmd_after_off[COUNT_CONTROL_STATION];  //     ,   Go.      /.

    unsigned int active_control_station[COUNT_CONTROL_STATION];         //   ,      ?

    unsigned int detect_get_data_control_station[COUNT_CONTROL_STATION];         //     ,    ,    update_timers


    unsigned int alive_control_station[COUNT_CONTROL_STATION];    //        


    int array_cmd[COUNT_CONTROL_STATION][CONTROL_STATION_CMD_LAST]; //       ,   parse
    int active_array_cmd[CONTROL_STATION_CMD_LAST];                 //      ,   parse

    WORD_UINT2BITS_STRUCT raw_array_data[COUNT_CONTROL_STATION][CONTROL_STATION_MAX_RAW_DATA]; //        ,  parse.
    WORD_UINT2BITS_STRUCT raw_array_data_temp[COUNT_CONTROL_STATION][CONTROL_STATION_MAX_RAW_DATA][CONTROL_STATION_MAX_RAW_DATA_TEMP]; //         ,  parse.

    unsigned int flag_message_sent[COUNT_CONTROL_STATION];       //       -
    unsigned int flag_waiting_answer[COUNT_CONTROL_STATION];       //      -

    unsigned int count_ok_modbus[COUNT_CONTROL_STATION];       //     modbus 15
    unsigned int count_error_modbus[COUNT_CONTROL_STATION];       //     modbus 15

    unsigned int flag_refresh_array[COUNT_CONTROL_STATION];       //       modbus

/*
    unsigned int cmd_go_from_control_station[COUNT_CONTROL_STATION];       // cmd_go   / 
    unsigned int set_izad_from_control_station[COUNT_CONTROL_STATION];       //   
    unsigned int set_rotor_from_control_station[COUNT_CONTROL_STATION];       //   
    unsigned int cmd_charge_from_control_station[COUNT_CONTROL_STATION];       //    
    unsigned int cmd_uncharge_from_control_station[COUNT_CONTROL_STATION];       //    
    unsigned int cmd_checkback_from_control_station[COUNT_CONTROL_STATION];       //   
    unsigned int cmd_test_leds_from_control_station[COUNT_CONTROL_STATION];       //    
*/
    unsigned int prev_CAN_count_cycle_input_units[COUNT_CONTROL_STATION];   //  -   CAN
    unsigned int count_raw_array_data_temp[COUNT_CONTROL_STATION];   //    CONTROL_STATION_MAX_RAW_DATA_TEMP

    void (*clear)();             // Clear buffers
    void (*update_timers)();                       //        
    void (*detect_active_station)();       //    

} CONTROL_STATION;

typedef CONTROL_STATION *CONTROL_STATION_handle;



#define CONTROL_STATION_DEFAULTS {  \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                {0}, \
                                control_station_clear, \
                                control_station_update_timers, \
                                control_station_detect_active_station \
}




void control_station_clear(CONTROL_STATION_handle);
void control_station_update_timers(CONTROL_STATION_handle);
void control_station_detect_active_station(CONTROL_STATION_handle);




extern CONTROL_STATION control_station;



#endif /* SRC_LIBS_NIO12_CONTROL_STATION_H_ */
