#include <stdio.h>

//  
double kp = 0.5;  //   
double ki = 0.2;  //   
double e_prev = 0; //   
double i_term = 0; //  

// ,   
double calculate_control_action(double setpoint, double process_variable)
{
    double error = setpoint - process_variable; //  

    //   
    i_term += ki * error;

    //    
    double adaptive_kp = kp / (1 + (i_term * i_term));

    //   
    double control_action = adaptive_kp * error + i_term;

    //    
    e_prev = error;

    return control_action;
}

int main()
{
    double setpoint = 25.0; //  
    double process_variable = 20.0; //  

    //   
    printf("Control action: %f\n", calculate_control_action(setpoint, process_variable));

    return 0;
}


