#ifndef __ABC_DQ_H__
#define __ABC_DQ_H__



typedef struct { _iq Ia; //phase A voltage, input
			 	 _iq Ib; //phase B voltage, input
				 _iq Ic; //phase C voltage, input
				 _iq Tetta; //phase angle, input
				 _iq Id; // axis d voltage, output
			 	 _iq Iq; // axis q voltage, output
				 void (*calc)(); // Pointer to calculation function
				 void (*calc_v2)(); // Pointer to calculation function
				 }ABC_TO_DQ;





typedef ABC_TO_DQ *ABC_TO_DQ_handle;

#define ABC_TO_DQ_DEFAULTS { 0, \
						    0, \
						    0, \
						    0, \
						    0, \
						    0, \
						    (void (*)(Uint32))abc_to_dq_calc, \
						    (void (*)(Uint32))abc_to_dq_calc_v2 } 


void abc_to_dq_calc(ABC_TO_DQ_handle);
void abc_to_dq_calc_v2(ABC_TO_DQ_handle);








#endif // end __ABC_DQ_H
