#ifndef _RS_FUNCTIONS_H
#define _RS_FUNCTIONS_H


#define MAX_RECEIVE_LENGTH		254
#define MAX_SEND_LENGTH			400 //266	//254

#define CMD_RS232_MODBUS_1			1
#define CMD_RS232_MODBUS_3			3
#define CMD_RS232_MODBUS_4			4
#define CMD_RS232_MODBUS_5			5
#define CMD_RS232_MODBUS_6			6
#define CMD_RS232_MODBUS_15			15
#define CMD_RS232_MODBUS_16			16

#define RS_TIME_OUT 6000
#define RS_TIME_OUT_MPU 6000//6000  //    
#define RS_TIME_OUT_HMI 1000
#define RS_TIME_OUT_MAX 10000
#define RS_TIME_OUT_LOST 1000



typedef unsigned char CHAR;

// Message RS declaration
typedef struct {
	unsigned int    commnumber; //  
	unsigned long	RS_Length; //  
	
	unsigned int	*pRS_RecvPtr; //  
	unsigned int	*pRS_SendPtr; //  
    unsigned int    *pRS_SendPtr_stage1; //  
    unsigned int    *pRS_SendPtr_stage2; //  
	unsigned int	*pRecvPtr;
	
	unsigned int	RS_PrevCmd; //  
	unsigned int	RS_Cmd; //  
	unsigned int	RS_Header[MAX_RECEIVE_LENGTH]; // 

	unsigned int	flag_TIMEOUT_to_Send; //     
	unsigned int	flag_TIMEOUT_to_Receive; //     
	unsigned int	RS_DataReady; //   RS 
	unsigned int	buffer[MAX_SEND_LENGTH]; //     RS
    unsigned int    buffer_stage1[8]; //     RS
//    unsigned int    buffer_stage2[8]; //     RS
	
	unsigned int	addr_answer; //      
	unsigned int	addr_recive;//     
	unsigned int	flag_LEADING; //    (  )
	unsigned long	RS_RecvLen;
	unsigned long	RS_SLength;	//    
	unsigned long	RS_SendLen; //    

    unsigned long   RS_SLength_stage1; //    
    unsigned long   RS_SLength_stage2; //    

	unsigned int	time_wait_rs_out;
	unsigned int	time_wait_rs_out_mpu;
    unsigned int    time_wait_rs_lost; //      -  !!!


	char	RS_SendBlockMode;				/*   */
    char    RS_SendBlockMode_stage1;               /*   */
    char    RS_SendBlockMode_stage2;               /*   */
	char	RS_Flag9bit;					/*  RS485???????? */

	int		BS_LoadOK;/**     */
	int		RS_FlagBegin;
	int		RS_HeaderCnt;
	int		RS_FlagSkiping;

	int     RS_DataReadyAnswer; // ,       ,   
    int     RS_DataReadyAnswerAnalyze; // ,       ,      

    int     RS_DataSended; // ,     ,     
    int     RS_DataWillSend; // ,             

    int     RS_DataReadyRequest; // ,    ,   
    int     RS_DataReadyFullUpdate; // ,        

    int     RS_OnTransmitedData ; //       
    int     current_tx_stage;
    int     cmd_tx_stage;

    unsigned int count_recive_ok; //     crc,
    unsigned int count_recive_error_crc; //  crc
    unsigned int count_recive_dirty;  //     crc,      
    unsigned int count_recive_bad;  //   c  
    unsigned int count_recive_bytes_all; //   
    unsigned int count_recive_bytes_skipped; //   
    unsigned int count_recive_cmd_skipped; //   
    unsigned int count_recive_rxerror; //   

    unsigned int do_resetup_rs; //     .

    int     RS_DataWillSend2; // 2,             




	} RS_DATA_STRUCT;

#define RS_DATA_STRUCT_DEFAULT  {0,0,0,0,0,0,0,0,0,{0}, 0,0,0,{0},{0}, 0,0,0,0,0,0, 0,0, 0,0, 0,0,0,0, 0,0, 0,0,0, 0, 0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0, 0,0}
//////////////////////////////////////////////////////////

#define TMS_TO_TERMINAL_TEST_ALL_STRUCT_DEFAULT {{0}, {0}, {0}, 0, 0, 0}

enum {
	CMD_RS232_LOAD = 51, CMD_RS232_UPLOAD, CMD_RS232_RUN, CMD_RS232_XFLASH, CMD_RS232_TFLASH,
	CMD_RS232_PEEK, CMD_RS232_POKE, CMD_RS232_INITLOAD, CMD_RS232_INIT,CMD_RS232_EXTEND,
	CMD_RS232_VECTOR = 61, CMD_RS232_IMPULSE, CMD_RS232_STD = 65, CMD_RS232_TEST_ALL, CMD_RS232_STD_ANS,
	CMD_RS232_LAST
	};

//enum {
//	false = 0, true
//	};

#define RS_LEN_CMD  CMD_RS232_LAST

//extern RS_DATA_STRUCT RS232_A, RS232_B;
extern RS_DATA_STRUCT rs_a,rs_b;

int RS_Send(RS_DATA_STRUCT *rs_arr,unsigned int *pBuf,unsigned long len);
void RS232_WorkingWith(unsigned int enable_rs_a, unsigned int enable_rs_b, unsigned int enable_int_timeout);
void RS232_TuneUp(unsigned long speed_baud_a, unsigned long speed_baud_b);
void inc_RS_timeout_cicle(void);
void resetup_rs_on_timeout_lost(int rsp);

void resetup_rs(RS_DATA_STRUCT *rs_arr);
void resetup_mpu_rs(RS_DATA_STRUCT *rs_arr);
int test_rs_live(RS_DATA_STRUCT *rs_arr);
void RS_SetControllerLeading(RS_DATA_STRUCT *RS232_Arr,int boool);
void RS_SetAdrAnswerController(RS_DATA_STRUCT *RS232_Arr,int  set_addr_answer);
void SetCntrlAddr (int cntrl_addr,int cntrl_addr_for_all);

extern float KmodTerm, freqTerm;
extern unsigned int RS_Len[RS_LEN_CMD];
extern int flag_special_mode_rs, disable_flag_special_mode_rs;

#endif
