/*
 * control_station_project.h
 *
 *  Created on: 1 . 2020 .
 *      Author: Yura
 */

#ifndef SRC_MAIN_CONTROL_STATION_PROJECT_H_
#define SRC_MAIN_CONTROL_STATION_PROJECT_H_


#define POS_STATION_CMD_ANOTHER_BSU1    15 //     CONTROL_STATION_CMD     


//   :
/*
 *  - RS232 -   PC
 *  - CAN -   PC
 *  ingeteam - RS485
 *   - RS485
 *    - CAN
 *    - RS485
 *    - CAN
 *    - CAN
 *   - CAN
 *  2 - CAN
 *  - - CAN
 *
 */

enum
{
 CONTROL_STATION_TERMINAL_RS232    =      0,
 CONTROL_STATION_TERMINAL_CAN,

 CONTROL_STATION_INGETEAM_PULT_RS485,
 CONTROL_STATION_MPU_SVU_CAN, // svu
 CONTROL_STATION_MPU_KEY_CAN, // bsu key
 CONTROL_STATION_MPU_SVU_RS485, // ?
 CONTROL_STATION_MPU_KEY_RS485, // ?
 CONTROL_STATION_ZADATCHIK_CAN, // bsu zo
 CONTROL_STATION_VPU_CAN, // vpu
 CONTROL_STATION_ANOTHER_BS, //      slave/master
 CONTROL_STATION_LAST  //    ,   ,   ,    .
};


enum
{
 CONTROL_STATION_CMD_GO    =      0,// cmd_go   / 
 CONTROL_STATION_CMD_SET_IZAD,//   
 CONTROL_STATION_CMD_SET_ROTOR,//   
 CONTROL_STATION_CMD_SET_POWER,//   
 CONTROL_STATION_CMD_CHARGE,   //    
 CONTROL_STATION_CMD_UNCHARGE, //    
 CONTROL_STATION_CMD_CHECKBACK,//   
 CONTROL_STATION_CMD_TEST_LEDS,//    
 CONTROL_STATION_CMD_ACTIVE_CONTROL,//   ,      .
                                    //   -    
 CONTROL_STATION_CMD_UFCONST_VECTOR,// Mode 0-ufconst, 1 - /
 CONTROL_STATION_CMD_ROTOR_POWER,   // Mode 0-, 1 - 
 CONTROL_STATION_CMD_SCALAR_FOC,   // Mode 0-, 1 - 
 CONTROL_STATION_CMD_SET_KM,// Km   Mode 0-ufconst
// CONTROL_STATION_CMD_SET_I_VOZBUD, //   
 CONTROL_STATION_CMD_SET_U_ZARYAD, //    
 CONTROL_STATION_CMD_SET_K_U_DISBALANCE, //     .    ,  >0   
 CONTROL_STATION_CMD_SET_K_PLUS_U_DISBALANCE, //kplus_u_disbalance,  =0,    ,   . ,  <>0    .
 CONTROL_STATION_CMD_MODE_PUMP, //   // // 0 - auto on - rand pump
                                 // 1 - auto on  1 pump
                                 // 2 - auto on  2 pump
                                 // 3 - manual on 1 pump
                                 // 4 - manual on 2 pump
                                 // 5-   manual   
 CONTROL_STATION_CMD_DISABLE_ON_PUMP,
 CONTROL_STATION_CMD_ENABLE_ON_CHARGE,
 CONTROL_STATION_CMD_DISABLE_ON_QTV,
 CONTROL_STATION_CMD_MANUAL_DISCHARGE,
 CONTROL_STATION_CMD_DISABLE_ON_UMP,
 CONTROL_STATION_CMD_WDOG_OFF,
 CONTROL_STATION_CMD_SET_LIMIT_POWER,//    
 CONTROL_STATION_CMD_BLOCK_BS,  //    
 CONTROL_STATION_CMD_DISABLE_INTERRUPT_SYNC,
 CONTROL_STATION_CMD_DISABLE_INTERRUPT_TIMER2,
 CONTROL_STATION_CMD_DISABLE_RASCEPITEL, //   ,        
 CONTROL_STATION_CMD_PWM_TEST_LINES, //    96   ,   !!!
 CONTROL_STATION_CMD_STOP_LOGS, //  
 CONTROL_STATION_CMD_LAST     //    ,   ,   ,    .
};


void control_station_test_alive_all_control(void);
int control_station_select_active(void);
int get_current_station_control(void);
void load_parameters_from_active_control_station(int current_control);
void parse_parameters_from_all_control_station(void);
void parse_parameters_from_one_control_station_terminal_rs232(int cc);
void parse_parameters_from_one_control_station_pult_ingeteam(int cc);
void parse_parameters_from_one_control_station_pult_zadat4ik(int cc);
void parse_parameters_from_one_control_station_pult_vpu(int cc);
void parse_parameters_from_one_control_station_another_bs(int cc);
void parse_parameters_from_one_control_station_MPU_SVU(int cc);

void parse_analog_data_from_active_control_station_to_alg(void);
void parse_data_from_master_to_alg(void);

void load_parameters_from_can_control_station_to_rs232(void);


#endif /* SRC_MAIN_CONTROL_STATION_PROJECT_H_ */
