/**
**************************************************************************
* @file mcu_app_includes.h
* @brief Заголовочный файл для оболочки МК.
**************************************************************************
@details
Главный заголовочный файл для матлаба. Включает дейфайны для S-Function,
объявляет базовые функции для симуляции МК и подключает базовые библиотеки:
- для симуляции		    "stm32fxxx_matlab_conf.h"
- для S-Function		"simstruc.h"
- для потоков			<process.h>
**************************************************************************/
#ifndef _APP_INCLUDES_H_
#define _APP_INCLUDES_H_

// Includes
#include "DSP281x_Device.h"

#include "def.h"

#include "edrk_main.h"
#include "vector.h"
#include "vector_control.h"
#include "adc_tools.h"
#include "uf_alg_ing.h"
#include "v_rotor.h"
#include "v_rotor_22220.h"
#include "v_pwm24_v2.h"
#include "control_station.h"
#include "control_station_project.h"
#include "CAN_Setup.h"
#include "RS_Functions.h"
#include "master_slave.h"
#include "xp_write_xpwm_time.h"
#include "global_time.h"
#include "PWMTools.h"
#include "alg_simple_scalar.h"

#include <params.h>
#include <params_alg.h>
#include <params_norma.h>
#include <params_pwm24.h>
#include <params_temper_p.h>
#include <project.h>

#endif //_APP_INCLUDES_H_